package com.project.zcustom.service.unit;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;

import com.project.zcustom.controller.core.PageParamVo;
import com.project.zcustom.domain.addional.LargeIssue;

import java.util.Date;
import java.util.List;

/**
 * 上报问题Service接口
 *
 * @author change
 * @date 2024-12-30
 */
public interface ILargeIssueService extends IService<LargeIssue> {

    /**
     * 分页查询上报问题列表
     *
     * @param largeIssue 上报问题
     * @return 上报问题集合
     */
    public IPage<LargeIssue> pagingLargeIssueList(LargeIssue largeIssue);

    /**
     * 分页查询上报问题列表
     *
     * @param lqw
     * @return 上报问题集合
     */
    public IPage<LargeIssue> pagingLargeIssueList(PageParamVo pageParamVo, LambdaQueryWrapper<LargeIssue> lqw);

    /**
     * 查询上报问题列表
     *
     * @param largeIssue 上报问题
     * @return 上报问题集合
     */
    public List<LargeIssue> selectLargeIssueList(LargeIssue largeIssue);

    /**
     * 查询上报问题列表
     *
     * @param largeIssue 上报问题
     * @return 上报问题集合
     */
    public List<LargeIssue> selectLargeIssueList(LargeIssue largeIssue,Long limitNum);

    /**
     * 根据指定字段查询信息
     *
     * @param field 字段名称
     * @param filedValue 字段值
     * @return 上报问题
     */
    public LargeIssue getLargeIssueByField(String field, String filedValue);

    /**
     * 根据指定字段查询信息列表
     *
     * @param field 字段名称
     * @param filedValue 字段值
     * @return 上报问题
     */
    public List<LargeIssue> selectLargeIssueListByField(String field, String filedValue);

    /**
     * 根据指定字段查询信息列表
     *
     * @param field 字段名称
     * @param filedValue 字段值
     * @return 上报问题
     */
    public List<LargeIssue> selectLargeIssueListByField(String field, String filedValue,Long limitNum);

    /**
     *判断指定字段值是否存在
     *
     * @param field 字段名称
     * @param filedValue 字段值
     */
    public void checkFieldExist(String field, String filedValue,String tips,Long id);

    /**
     *  真删接口
     */
    public void reallyDeleteLargeIssue(LambdaQueryWrapper<LargeIssue> lqw);

    public int getIssueNum(String appOrg);

    public int getOverIssueNum(String appOrg);

    public List<LargeIssue> getIssueListLastWeek(String appOrg, Date date);

    public List<LargeIssue> selectList(LargeIssue largeIssue);
    public LargeIssue selectLargeIssueById(Long id);
}
